blog/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Route::get('appointments/filter','AppointmentController@filter')->name('appointments.filter');
Route::resource('appointments','AppointmentController');

blog/app/Appointment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Appointment extends Model
{
    //
    protected $table = "appointments";
    protected $fillable = ['date', 'price', 'dentist_id','patient_id','service_id'];

    public function dentist(){
    	return $this->belongsTo('App\Dentist');
    }

    public function patient(){
    	return $this->belongsTo('App\Patient');
    }

    public function service(){
    	return $this->belongsTo('App\Service');
    }
}

blog/app/Dentist.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Dentist extends Model
{
    //
    protected $table = "dentists";
}

blog/app/Patient.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Patient extends Model
{
    //
    protected $table = "patients";
}

blog/app/Service.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Service extends Model
{
    //
    protected $table = "services";
}

blog/app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

blog/app/Http/Controllers/AppointmentController.php
<?php

namespace App\Http\Controllers;

use App\Appointment;
use App\Dentist;
use App\Service;
use App\Patient;
use Illuminate\Http\Request;

class AppointmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $appointments = Appointment::all();
        $profit = 0;
        $appointment_total = 0;
        $service_total = 0;
        foreach ($appointments as $appointment => $a) {
            $appointment_total = $appointment_total + $a->price;
            $service_total = $service_total + $a->service->price;
        }
        $profit = $appointment_total - $service_total;
        return view('appointment.list',compact('appointments','profit'));
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function filter(Request $request)
    {
        if($request != null){
            $appointments = Appointment::all()->where('date','>=',$request->input('datei'))
            ->where('date','<=',$request->input('datef'));
            $profit = 0;
            $appointment_total = 0;
            $service_total = 0;
            foreach ($appointments as $appointment => $a) {
                $appointment_total = $appointment_total + $a->price;
                $service_total = $service_total + $a->service->price;
            }
            $profit = $appointment_total - $service_total;
            return view('appointment.filter',compact('appointments','profit'));

        }else{
            $appointments = Appointment::all();
            return view('appointment.filter',compact('appointments'));
        }

    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $dentists = Dentist::all();
        $services = Service::all();
        $patients = Patient::all();
        return view('appointment.create',compact('services','dentists','patients'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $request->validate([
            'date' => 'required',
            'price' => 'required',
            'dentist_id' => 'required|integer',
            'patient_id' => 'required|integer',
            'service_id' => 'required|integer',
        ]);

        Appointment::create($request->all());
        return redirect()->route('appointments.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Appointment  $appointment
     * @return \Illuminate\Http\Response
     */
    public function show(Appointment $appointment)
    {
        //
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Appointment  $appointment
     * @return \Illuminate\Http\Response
     */
    public function edit(Appointment $appointment)
    {
        //
        $dentists = Dentist::all();
        $services = Service::all();
        $patients = Patient::all();
        return view('appointment.edit',compact('appointment','dentists','services','patients'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Appointment  $appointment
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Appointment $appointment)
    {
        //
        $request->validate([
            'date' => 'required',
            'price' => 'required',
            'dentist_id' => 'required|integer',
            'patient_id' => 'required|integer',
            'service_id' => 'required|integer',
        ]);

        $appointment->update($request->all());
  
        return redirect()->route('appointments.index')->with('exito','Consulta modificada correctamente');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Appointment  $appointment
     * @return \Illuminate\Http\Response
     */
    public function destroy(Appointment $appointment)
    {
        //
        
        $appointment->delete();
        return redirect()->route('appointments.index')->with('exito','Consulta eliminada correctamente');
    }
}

blog/app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

blog/resources/views/appointment/create.blade.php
@extends('welcome')
@section('navbar')
@parent
@endsection
@section('content')
<h1 class="text-center">Agendar Consulta Dental</h1>
@if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif
<div class="card ">
    <form action="{{route('appointments.store')}}" method="post">
        @csrf
        <div class="card-body">
            <br>
            <div class="row form-group">
                <label for="service" class="col-md-2">Servicio </label>
                <select name="service_id" id="service" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($services as $service)
                        <option value="{{$service->id}}">{{$service->name}}</option>
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="dentist" class="col-md-2">Médico Tratante </label>
                <select name="dentist_id" id="dentist" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($dentists as $dentist)
                        <option value="{{$dentist->id}}">{{$dentist->name}}</option>
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="patient" class="col-md-2">Nombre Paciente </label>
                <select name="patient_id" id="patient" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($patients as $patient)
                        <option value="{{$patient->id}}">{{$patient->name}}</option>
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="price" class="col-md-2">Costo Servicio </label>
                <div class="col-md-6" style="padding-left: 0;padding-right: 0;">
                    <div class="input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">$</span>
                        </div>
                        <input type="number" name="price" id="price" class="form-control">
                    </div>
                </div>
            </div>
            <div class="row form-group">
                <label for="date" class="col-md-2">Fecha Servicio </label>
                <input type="date" name="date" id="date" class="form-control col-md-6">
            </div>
            <div class="row">
                <button type="submit" class="btn btn-primary col-md-4 offset-2">Agendar Consulta</button>
            </div>
        </div>
    </form>
</div>
@endsection
@section('custom')
<script type="text/javascript">
            function val(value){
                $('#price').val(value);
            }
            $('#service').change(function(){
                val(value);
            });

        
        //console.log(costo);
</script>
@endsection

blog/resources/views/appointment/edit.blade.php
@extends('welcome')
@section('navbar')
@parent
@endsection
@section('content')
<h1 class="text-center">Agendar Consulta Dental</h1>
@if ($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif
<div class="card ">
    <form action="{{route('appointments.update',$appointment->id)}}" method="post">
        @csrf
        @method('PUT')
        <div class="card-body">
            <br>
            <div class="row form-group">
                <label for="service" class="col-md-2">Servicio </label>
                <select name="service_id" id="service" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($services as $service)
                        @if($appointment->service_id == $service->id)
                            <option value="{{$service->id}}" selected="selected">{{$service->name}}</option>
                        @else
                            <option value="{{$service->id}}">{{$service->name}}</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="dentist" class="col-md-2">Médico Tratante </label>
                <select name="dentist_id" id="dentist" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($dentists as $dentist)
                        @if($appointment->dentist_id == $dentist->id)
                                <option value="{{$dentist->id}}" selected="selected">{{$dentist->name}}</option>
                        @else
                                <option value="{{$dentist->id}}">{{$dentist->name}}</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="patient" class="col-md-2">Nombre Paciente </label>
                <select name="patient_id" id="patient" class="form-control col-md-6">
                    <option>-</option>
                    @foreach($patients as $patient)
                        @if($appointment->patient_id == $patient->id)
                            <option value="{{$patient->id}}" selected="selected">{{$patient->name}}</option>
                        @else
                            <option value="{{$patient->id}}">{{$patient->name}}</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="row form-group">
                <label for="price" class="col-md-2">Costo Servicio </label>
                <div class="col-md-6" style="padding-left: 0;padding-right: 0;">
                    <div class="input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text">$</span>
                        </div>
                        <input type="number" name="price" id="price" class="form-control" value="{{$appointment->price}}">
                    </div>
                </div>
            </div>
            <div class="row form-group">
                <label for="date" class="col-md-2">Fecha Servicio </label>
                <input type="date" name="date" id="date" class="form-control col-md-6" value="{{$appointment->date}}">
            </div>
            <div class="row">
                <button type="submit" class="btn btn-primary col-md-4 offset-2">Editar Consulta</button>
            </div>
        </div>
    </form>
</div>
@endsection

blog/resources/views/appointment/filter.blade.php
@extends('welcome')
@section('navbar')
@parent
@endsection
@section('content')
<h1 class="text-center">Historial de Servicios</h1>
    <br>
    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    <div class="container">
        
        <form action="{{route('appointments.filter')}}" method="get">
                @csrf
            <div class="row form-group">
                <label for="datei" class="col-md-1">Desde: </label>
                <div class="col-md-4">
                    <input type="date" name="datei" id="datei" class="form-control col-md-12">
                </div>
                <label for="datef" class="col-md-1">Hasta: </label>
                <div class="col-md-4">
                    <input type="date" name="datef" id="datef" class="form-control col-md-12">
                </div>
                <div class="col-md-2">
                    <button type="submit" class="btn btn-primary">Filtrar</button>
                </div>
            </div>
        </form>
        <table class="table table-striped table-bordered" id="table">
            <thead>
                <th>Fecha Consulta</th>
                <th class="no-sort">Paciente</th>
                <th class="no-sort">Servicio</th>
                <th class="no-sort">Medico</th>
                <th class="no-sort">Precio Servicio</th>
                <th class="no-sort">Opciones</th>
            </thead>
            <tbody>
                @foreach($appointments as $appointment)
                <tr>
                    <td>{{$appointment->date}}</td>
                    <td>{{$appointment->patient->name}}</td>
                    <td>{{$appointment->service->name}}</td>
                    <td>{{$appointment->dentist->name}}</td>
                    <td>$ {{number_format($appointment->price,0,",",".")}}</td>
                    <td>
                        <form action="{{ route('appointments.destroy',$appointment->id) }}" method="post">
                            
                            
                            <a href="{{ route('appointments.edit',$appointment->id) }}" class="btn "><span><i class="fas fa-pencil-alt fa-sm"></i></span></a>
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn "><span><i class="fas fa-trash-alt fa-sm"></i></span></button>
                            
                        </form>
                        
                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
        <br>
        <h2>Ganancia Total por Periodo: $ {{number_format($profit,0,",",".")}} .-</h2>
    </div>
@endsection
@section('custom')
    
@endsection

blog/resources/views/appointment/list.blade.php
@extends('welcome')
@section('navbar')
@parent
@endsection
@section('content')
<h1 class="text-center">Historial de Servicios</h1>
    <br>
    <div class="container">
        <table class="table table-striped table-bordered" id="table">
            <thead>
                <th>Fecha Consulta</th>
                <th class="no-sort">Paciente</th>
                <th class="no-sort">Servicio</th>
                <th class="no-sort">Medico</th>
                <th class="no-sort">Precio Servicio</th>
                <th class="no-sort">Opciones</th>
            </thead>
            <tbody>
                @foreach($appointments as $appointment)
                <tr>
                    <td>{{$appointment->date}}</td>
                    <td>{{$appointment->patient->name}}</td>
                    <td>{{$appointment->service->name}}</td>
                    <td>{{$appointment->dentist->name}}</td>
                    <td>$ {{number_format($appointment->price,0,",",".")}}</td>
                    <td>
                        <form action="{{ route('appointments.destroy',$appointment->id) }}" method="post">
                            
                            
                            <a href="{{ route('appointments.edit',$appointment->id) }}" class="btn "><span><i class="fas fa-pencil-alt fa-sm"></i></span></a>
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn "><span><i class="fas fa-trash-alt fa-sm"></i></span></button>
                            
                        </form>
                        
                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
        <br>
        <h2>Ganancia Total: $ {{number_format($profit,0,",",".")}} .-</h2>
    </div>
@endsection
@section('custom')
    <script type="text/javascript">
        $(document).ready( function () {
            $('#table').DataTable({
                "paging":   false,
                "ordering": true,
                "info":     false,
                "searching": false,
                columnDefs: [{
                  orderable: false,
                  targets: "no-sort"
                }]
            });
        });
    </script>
@endsection